#!/usr/bin/env groovy //Jenkinsfile DSL (Declarative Syntax)

pipeline {

	agent any
	tools { 
        maven 'pacman-managed' 
        jdk 'pacman-managed-jdk13' 
    }


	stages {

		stage('Prepare') {
			steps {
				sh '''
                    echo "PATH = ${PATH}"
                    echo "JAVA_HOME = ${JAVA_HOME}"
                    echo "M2_HOME = ${M2_HOME}"
                    mvn --version
                '''
			}
		}

		stage('Compile') {
			steps {
				sh 'mvn -U clean compile'
			}
		}
		
		stage('Test') {
			steps {
				sh 'mvn test'
			}
		}
		
		stage('Package') {
			steps {
				sh 'mvn install -DskipCompile -DskipTests -P deploy'
			}
		}
		
		stage('Code Analysis') {
			steps {
				sh 'mvn spotbugs:check'
			}
		}
		
		stage('Deploy') {
			steps {
				sh 'mvn deploy -DskipCompile -DskipTests -DskipPackage'
			}
		}
	}
	
	post {
		always {
			junit '*/target/surefire-reports/*.xml'
		}
	}
}
